const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const leave_requests = sequelize.define(
    'leave_requests',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

start_at: {
        type: DataTypes.DATE,
      
      

      },

end_at: {
        type: DataTypes.DATE,
      
      

      },

leave_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"vacation",


"sick",


"public_holiday",


"training",


"other"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"requested",


"approved",


"rejected",


"cancelled"

        ],

      },

reason: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  leave_requests.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














































//end loop



    db.leave_requests.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.team_members, {
      as: 'team_member',
      foreignKey: {
        name: 'team_memberId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.users, {
      as: 'approver',
      foreignKey: {
        name: 'approverId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.leave_requests.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.leave_requests.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return leave_requests;
};


